'use strict';

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _commit = require('./commit'); // Copyright 2017-2018 Jaco Greeff
// This software may be modified and distributed under the terms
// of the ISC license. See the LICENSE file for details.


var _del = require('./del');
var _get = require('./get');
var _pairs = require('./pairs');
var _set = require('./set');

module.exports = function memory() {
  var storage = {};

  return {
    clear: function clear() {
      storage = {};
    },
    commit: function commit() {
      var values = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      return _commit(storage, values);
    },
    del: function del(k) {
      return _del(storage, k);
    },
    isEmpty: function isEmpty() {
      return (0, _keys2.default)(storage).length === 0;
    },
    get: function get(k) {
      return _get(storage, k);
    },
    pairs: function pairs() {
      return _pairs(storage);
    },
    set: function set(k, v) {
      return _set(storage, k, v);
    }
  };
};